require 'notify_makers_com/message'
require 'notify_makers_com/provider'

module NotifyMakersCom
  class Client

    def initialize(api_key)
      @site    = 'https://notifymakers.com'
      @api_key = api_key

      setup_connection
    end

    def create_message(provider, recipient, message)
      NotifyMakersCom::Message.create({ provider_id: provider, message: { recipient: recipient, message: message } })
    end

    def providers
      NotifyMakersCom::Provider.all
    end

    protected

    def setup_connection
      [NotifyMakersCom::Message, NotifyMakersCom::Provider].each do |klass|
        klass.site                 = @site
        klass.headers['X-API-Key'] = @api_key
        klass.format               = :json
        klass.include_root_in_json = true
      end
    end

  end
end
